#include <iostream>

typedef long long llong;
const int maxn = 1e5+10;
const int mod = 998244353;

int a[maxn], n;
int ones[maxn], twos[maxn];
llong powers[maxn];
int cnt[3];

void solve() 
{
    powers[0] = 1;
    for (int i = 1 ; i <= n ; ++i) powers[i] = (powers[i-1] * 2) % mod;
    for (int i = 1 ; i <= n ; ++i) ones[i] = ones[i-1] + (a[i] == 1);
    for (int i = n ; i >= 0 ; --i) twos[i] = twos[i+1] + (a[i] == 2);
    ones[0] = 1; a[0] = 1;

    llong ans = 0;
    for (int i = 0 ; i <= n ; ++i) 
    {
        if (a[i] != 1) continue;
        ans += (powers[ones[i]-1]) * powers[twos[i]];
        ans %= mod;
    }

    ans += mod - 1;
    ans %= mod;
    std::cout << ans << '\n';
}

void fastIO() 
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void read() 
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i) std::cin >> a[i];
}

int main () 
{
    fastIO();
    read();
    solve();

    return 0;
}