#include <iostream>
#include <algorithm>

const int maxn = 100000 + 10;
const int mod = 998244353;

int a[maxn], n;
int tree[4*maxn];

void update(int l, int r, int node, int queryIx, int queryValue) 
{
    if (l == r) 
    {
        tree[node] += queryValue;
        if (tree[node] >= mod) tree[node] -= mod;
        return;
    }

    int mid = (l+r)/2;
    if (queryIx <= mid) update(l, mid, 2*node, queryIx, queryValue);
    else update(mid+1, r, 2*node+1, queryIx, queryValue);

    tree[node] = tree[2*node] + tree[2*node+1];
    if (tree[node] >= mod) tree[node] -= mod;
}

int query(int l, int r, int node, int queryIx) 
{
    if (r <= queryIx) return tree[node];

    int mid = (l+r)/2, ans = query(l, mid, 2*node, queryIx);
    if (mid+1 <= queryIx) ans += query(mid+1, r, 2*node+1, queryIx);
    if (ans >= mod) ans -= mod;

    return ans;
}

std::pair < int, int > sorted[maxn];
void solve() 
{
    for (int i = 1 ; i <= n ; ++i)  
        sorted[i] = {a[i], i};

    std::sort(sorted+1, sorted+1+n);

    int cnt = 0;
    for (int i = 1 ; i <= n ; ++i) 
    {
        cnt += (sorted[i].first != sorted[i-1].first);
        a[sorted[i].second] = cnt;

    }
    
    int ans = 0;
    for (int i = 1 ; i <= n ; ++i) 
    {
        int curr = query(1, n, 1, a[i]) + 1;
        ans += curr;
        if (ans >= mod) ans -= mod;

        update(1, n, 1, a[i], curr);
    }

    std::cout << ans << '\n';
}

void fastIO() 
{
    std::ios_base :: sync_with_stdio(0);
    std::cin.tie(nullptr);
    std::cout.tie(nullptr);
}

void read() 
{
    std::cin >> n;
    for (int i = 1 ; i <= n ; ++i)
        std::cin >> a[i];
}

int main () 
{
    fastIO();
    read();
    solve();

    return 0;
}